/*  AutoGL $B!c$*<j7Z!d(B $B$N%5%s%W%k%W%m%0%i%`Nc(B */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>

/* AutoGL $B!I$*$F$,$k!I$r;H$&$K$O(B,$B$3$N%X%C%@%U%!%$%k$r%$%s%/%k!<%I$9$k!#(B*/
#include <autogl.h>

/* $B%f!<%F%#%j%F%#$NFs<!85%$%Y%s%H=hM}$NMxMQ(B */
/* $B0z?t$J$I>\$7$$>pJs$O(B, autogl_utility2d.h$B$r;2>H!#(B*/
/* $B$J$*!"$3$l$O(Bautogl.h$B$+$i(Binclude$B$5$l$F$$$k!#(B*/



/* $B%S%e!<>e$KI=<($5$l$k%b%G%k$rI=8=$9$k$?$a$NJQ?t72(B */

/* $B8=:_A*Br$5$l$F$$$kD:E@$NHV9f(B */
static int SelectedVertexId = -1;

/* $BD:E@$N:BI8(B */
static double Vertexs[6][2] = {
  { 10, 0 },
  { 10, 20 },
  { 0, 20 },
  { -10, 0 },
  { 0, -20 },
  { 30, -20 }
};

static double CenterX, CenterY;



/* $B%S%e!<$N:FIA2h$N$?$a$N%3!<%k%P%C%/4X?t(B */
/* $B%S%e!<$,:FI=<($5$l$k$4$H$K8F$P$l$k!#(B */
static void RedrawView (void) 
{
  int i;
  int isFilled;

  AutoGL_SetColor (0, 1, 0);  

  AutoGL_DrawLine (-50 + CenterX, 0 + CenterY, 0,
 		    50 + CenterX, 0 + CenterY, 0); 
  AutoGL_DrawString (50 + CenterX, 0 + CenterY, 0, 
		     "X = 5O");  
  AutoGL_DrawString (-50 + CenterX, 0 + CenterY, 0, 
		     "X = -5O");  
  
  AutoGL_DrawLine (0 + CenterX, -50 + CenterY, 0,
		   0 + CenterX,  50 + CenterY, 0); 
  AutoGL_DrawString (0 + CenterX,  50 + CenterY, 0, "Y = 5O");  
  AutoGL_DrawString (0 + CenterX, -50 + CenterY, 0, "Y = -5O");  
    
  AutoGL_SetColor (1, 1, 1);
  AutoGL_DrawString (0 + CenterX, 0 + CenterY, 0, "O"); 

  AutoGL_SetColor (1, 1, 1);
  for (i = 0; i < 6 - 1; i++) {
    AutoGL_DrawLine (Vertexs[i][0] + CenterX, 
		     Vertexs[i][1] + CenterY, 
		     0,
		     Vertexs[i + 1][0] + CenterX, 
		     Vertexs[i + 1][1] + CenterY, 
		     0);
  }

  AutoGL_SetColor (1, 0, 0);
  
  /* $B3FD:E@$K$D$$$F!"$=$l$,A*Br$5$l$F$$$k$+$I$&$+$rIA2h$9$k!#(B */
  for (i = 0; i < 6; i++) {
    int markSizeDc = 10;

    isFilled = 0;
    if (i == SelectedVertexId) {
      isFilled = 1;
    }

    /* $B%@%$%"%b%s%I$N%^!<%/$rI=<($9$k!#(B */
    AutoGL_DrawDiamondMark2D 
      (Vertexs[i][0] + CenterX, 
       Vertexs[i][1] + CenterY, 
       0, 
       markSizeDc, isFilled);
    /* markSizeDc$B$K$h$j!"(B10 pixel$B$0$i$$$NBg$-$5$H$J$k!#(B */
    /* isFilled == 1$B$J$i!"$3$ND:E@$OA*Br$5$l$F$$$k!#(B */
  }
}

/* $B%S%e!<$N%$%Y%s%H=hM}$?$a$N%3!<%k%P%C%/4X?t(B */
/* $B%S%e!<$K%$%Y%s%H$,H/@8$9$k$4$H$K8F$P$l$k!#(B */
static void HandleEvent (void)
{
  /* $B$b$7!"%^%&%9%/%j%C%/$,$"$l$P(B */
  if (AutoGL_GetViewEvent () == AUTOGL_EVENT_POINTING_DEVICE_RELEASE) {
    int i;

    /* $B3FD:E@$K$D$$$F!"%^%&%9%]%$%s%?$,%R%C%H$7$?$+$I$&$+D4$Y$k!#(B */
    SelectedVertexId = -1;
    for (i = 0; i < 6; i++) {
      int toleranceDc = 10;

      /* $B$3$ND:E@$,%^%&%9%]%$%s%?$N$=$P$K$"$l$P(B */
      if (AutoGL_PointingDeviceIsHit2D 
	  (Vertexs[i][0] + CenterX, 
	   Vertexs[i][1] + CenterY, 
	   toleranceDc)) {
	/* $BE@$N:BI8$O@$3&:BI8!J$?$@$7Fs<!85!K$GM?$($k!#(B */
	SelectedVertexId = i;
	break;
      }
    }
    if (SelectedVertexId != -1) {
      printf (" vertex %d is selected. \n",
	      SelectedVertexId);
    }

    /* $B%S%e!<$r:FIA2h$9$k!#(B */
    AutoGL_DrawView ();
    /* $BEPO?$5$l$?%S%e!<$N:FIA2h4X?t!J$3$N>l9g$O(BRedrawView ()$B!K$,8F$P$l$k!#(B */
  } else if (AutoGL_GetViewEvent () == AUTOGL_EVENT_KEY) {
    int keyChar = AutoGL_GetKeyChar ();
    
    if (keyChar == ' ') {
      fprintf (stderr, "HIT SPACE\n");
    }
  }
}

static void IdleEvent (void)
{
  static int count = 1;
  static int choice;

  switch (choice) {
  case 0:
    CenterX += 0.1;
    break;
  case 1:
    CenterX -= 0.1;
    break;
  case 2:
    CenterY += 0.1;
    break;
  case 3:
    CenterY -= 0.1;
    break;
  }

  count--;
  if (count == 0) {
    count = 20;
    choice = rand () % 4;
  }

  AutoGL_DrawView ();
}

static void Animate (void) 
{
  static int idleEventIsOn = 0;

  if (idleEventIsOn) {
    /* $B%"%$%I%k%$%Y%s%H=hM}$NL58z2=(B */
    AutoGL_SetIdleEventCallback (NULL);   
    idleEventIsOn = 0;
  } else {
    /* $B%"%$%I%k%$%Y%s%H=hM}%3!<%k%P%C%/$NEPO?(B */
    AutoGL_SetIdleEventCallback (IdleEvent);   
    idleEventIsOn = 1;
  }
}



/* $B4X?t(BAutoGL_SetUp$B$O%f!<%6!<B&%W%m%0%i%`$4$H$KI,$:0l$DMQ0U$9$k$3$H!#(B*/
/* $B$3$3$G!"%3!<%k%P%C%/4X?t$d@)8fJQ?t$J$I$rEPO?$9$k!#(B*/
void AutoGL_SetUp (int argc, char *argv[]) 
{
  AutoGL_SetViewSize (70);   

  /* $B%S%e!<$N:FIA2h%3!<%k%P%C%/$NEPO?(B */
  AutoGL_SetViewRedrawCallback (RedrawView);   

  /* $B%S%e!<$N%$%Y%s%H=hM}%3!<%k%P%C%/$NEPO?(B */
  AutoGL_SetDefaultCallbackInMode2D (HandleEvent);
  /* $B%$%Y%s%H=hM}%3!<%k%P%C%/4X?t$H$7$F>e$K$"$k(BHandleEvent ()$B$r;XDj!#(B */
  /* $BFCJL$J%$%Y%s%H=hM}$,MW$i$J$1$l$P!"(BNULL$B$G$h$$!#(B*/

  /* $B%"%$%I%k%$%Y%s%H=hM}$NM-8z2=(B */
  AutoGL_EnableIdleEvent ();   

  /* $B%Q%M%k>e$KFs<!85%"%W%jMQ%$%Y%s%H=hM}5!G=$r=`Hw$9$k!#(B */
  AutoGL_SetPanelInMode2D ();

  AutoGL_AddCallback (Animate, "Animate");      
  
}

